using System;
using System.Linq;
using System.Collections.Generic;

namespace gg
{
    class Program
    {
        static bool f(int a, int pocetak, int kraj, int[] novi_niz, int broj) {
            for (int k = pocetak; k < kraj; k++)
            {
                if (broj > 0)
                {
                    if (novi_niz[k] < novi_niz[k - 1])
                    {
                        return false;
                    }
                }
                if (novi_niz[k] < novi_niz[k - 1])
                {
                    if (novi_niz[k] < novi_niz[a])
                    {
                        novi_niz[k - 1] = novi_niz[k];
                        broj++;
                    }
                    else
                    {
                        novi_niz[k] = novi_niz[k - 1];
                        broj++;
                    }
                }
                else
                {
                    novi_niz[k - 1] = a;
                }
            }
            if (broj > 1)
            {
                return false;
            }
            return true;
        }

        static void Main(string[] args)
        {

            int N = int.Parse(Console.ReadLine());
            int[] niz = new int[N];

            string[] s = Console.ReadLine().Split();
            for (int i = 0; i < N; i++)
            {
                niz[i] = int.Parse(s[i]);
            }
            int Q = int.Parse(Console.ReadLine());
            bool[] tacno = new bool[Q];
            int[] l = new int[Q];
            int[] r = new int[Q];
            for (int i = 0; i < Q; i++)
            {
                s = Console.ReadLine().Split();
                l[i] = int.Parse(s[0]);
                r[i] = int.Parse(s[1]);
                tacno[i] = true;
            }
            int broj = 0;
            for (int i = 0; i < Q; i++)
            {
                broj = 0;
                int a = l[i] - 1;
                int pocekat = l[i];
                int kraj = r[i];
                tacno[i] = f(a, pocekat, kraj, niz, broj);
            }
            foreach (bool x in tacno)
            {
                Console.WriteLine(x ? "DA" : "NE");
            }
            Console.ReadLine();
        }


    }

}